' --------------------------------------------------------------------------
' This script is designed to be used in conjunction with Samurize to get all the
' information you want about the servers for MXO ( Matrix Online )
' There is no need to edit anything in this script, just use it and enjoy
' --------------------------------------------------------------------------
' This script was created by Joakim Lindqvist (c) 2005
' Ingame name is JoCCo, email: graciaetewen@telia.com
' More information can be found @ www.slackerstudios.se
' --------------------------------------------------------------------------


'Some Constants used to make the code more readable
Const URL = "http://thematrixonline.warnerbros.com/web/live/index.jsp"
Const Parser = 0
Const Subroutine = 1
Const XORServer = 2
Const BooleanServer = 3
Const Algorithm  = 4
Const NOFSERVERS = 5
Const Name = 0
Const Status = 1
Const Population = 2
Const Version = 3
Const NOFVALUES = 4

' Parser Functions
Function GetParserStatus()
	GetParserStatus = getStatus(Parser, Status)
End Function
Function GetParserVersion()
	GetParserVersion = getStatus(Parser, Version )
End Function
Function GetParserPopulation()
	GetParserPopulation = getStatus(Parser, Population ) 
End Function


' Subroutine Functions
Function GetSubroutineStatus()
	GetSubroutineStatus = getStatus(Subroutine, Status)
End Function
Function GetSubroutineVersion()
	GetSubroutineVersion = getStatus(Subroutine, Version )
End Function
Function GetSubroutinePopulation()
	GetSubroutinePopulation = getStatus(Subroutine, Population ) 
End Function


' XOR Functions
Function GetXORStatus()
	GetXORStatus = getStatus(XORServer, Status)
End Function
Function GetXORVersion()
	GetXORVersion = getStatus(XORServer, Version )
End Function
Function GetXORPopulation()
	GetXORPopulation = getStatus(XORServer, Population ) 
End Function


' Boolean Functions
Function GetBooleanStatus()
	GetBooleanStatus = getStatus(BooleanServer, Status)
End Function
Function GetBooleanVersion()
	GetBooleanVersion = getStatus(BooleanServer, Version )
End Function
Function GetBooleanPopulation()
	GetBooleanPopulation = getStatus(BooleanServer, Population ) 
End Function

' Algorithm Functions
Function GetAlgorithmStatus()
	GetAlgorithmStatus = getStatus(Algorithm, Status)
End Function
Function GetAlgorithmVersion()
	GetAlgorithmVersion = getStatus(Algorithm, Version )
End Function
Function GetAlgorithmPopulation()
	GetAlgorithmPopulation = getStatus(Algorithm, Population ) 
End Function

' --- The Functions below this should not be called from Samurize!

'Internal function that parses the html file and returns the information
Function getStatus(server, value)
	Dim html
	ReDim strStatus(NOFSERVERS), strPopulation(NOFSERVERS), strVersion(NOFSERVERS)
	html = ReturnHTML(URL)
	

	Set RE = New RegExp
	RE.Global = True
	
	RE.Pattern = "<span class='status_(.*?)</span>"
	For iStatus = 0 To NOFSERVERS - 1
		Set statusTemp = RE.Execute( html )
		Set fullMatch  = statusTemp(iStatus)
		strStatus(iStatus) = Split( fullMatch.SubMatches(0), ">", 2)(1)
	Next
	RE.Pattern = "<br>Population: (.*?)<br>"
	For iPopulation =0 To NOFSERVERS -1
		Set popTemp = RE.Execute( html )
		strPopulation(iPopulation) = popTemp(iPopulation).SubMatches(0)
	Next
	RE.Pattern = "<br>Version: (.*?)</div>"
	For iVersion =0 To NOFSERVERS -1
		Set versionTemp = RE.Execute( html )
		Set fullMatch = versionTemp(iVersion)
		strVersion(iVersion) = fullMatch.SubMatches(0)
	Next
	
	If value = Status Then
		getStatus = strStatus(server)
	Elseif value = Population Then
		getStatus = strPopulation(server)
	Elseif value = Version Then
		getStatus = strVersion(server)
	Else
		getStatus = "Incorrect value supplied, correct values are : 1 for Status, 2 for Population, 3 for Version"
	End If
End Function

' Function that connect to the webpage and downloads it
Function ReturnHTML(sURL)
    Randomize
    Dim objXMLHTTP, HTML
    Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
    objXMLHTTP.Open "GET", sURL, False
    objXMLHTTP.Send
    HTML = objXMLHTTP.responseBody
    Set objRS = CreateObject("ADODB.Recordset")
    objRS.Fields.Append "txt", 200, 45000, &H80
    objRS.Open
    objRS.AddNew
    objRS.Fields("txt").AppendChunk HTML
    ReturnHTML = objRS("txt").Value
    objRS.Close
    Set objRS = Nothing
    Set objXMLHTTP = Nothing
End Function